Codeforces Round #305 (Div. 2) B

Description

Mike and some bears are playing a game just for fun. Mike is the judge. All bears except Mike are standing in an n × m grid, there‘s exactly one bear in each cell. We denote the bear standing in column number j of row number i by (i, j). Mike‘s hands are on his ears (since he‘s the judge) and each bear standing in the grid has hands either on his mouth or his eyes.

They play for q rounds. In each round, Mike chooses a bear (i, j) and tells him to change his state i. e. if his hands are on his mouth, then he‘ll put his hands on his eyes or he‘ll put his hands on his mouth otherwise. After that, Mike wants to know the score of the bears.

Score of the bears is the maximum over all rows of number of consecutive bears with hands on their eyes in that row.

Since bears are lazy, Mike asked you for help. For each round, tell him the score of these bears after changing the state of a bear selected in that round.

Input

The first line of input contains three integers nm and q (1 ≤ n, m ≤ 500 and 1 ≤ q ≤ 5000).

The next n lines contain the grid description. There are m integers separated by spaces in each line. Each of these numbers is either 0 (for mouth) or 1 (for eyes).

The next q lines contain the information about the rounds. Each of them contains two integers i and j (1 ≤ i ≤ n and 1 ≤ j ≤ m), the row number and the column number of the bear changing his state.

Output

After each round, print the current score of the bears.

Examples

input

5 4 50 1 1 01 0 0 10 1 1 01 0 0 10 0 0 01 11 41 14 24 3

output

34334

求每次更改连续1的最长长度,我们可以只记录发生更改的一行,然后遍历所有行就好。

(不过貌似可以每次都遍历一次也能AC,不过我超时了)

#include<iostream>
#include<stdio.h>
#include<algorithm>
using namespace std;
int main()
{

    int n,m,t;
    int mp[510][510];
   // int maxn=-1;
    int d[510];
    cin>>n>>m>>t;
    for(int i=1; i<=n; i++)
    {
        int num=0;
        int maxn=-1;
        for(int j=1; j<=m; j++)
        {
            cin>>mp[i][j];
        }
        for(int j=1; j<=m; j++)
        {
            if(mp[i][j]==1)
            {
                num++;
                maxn=max(num,maxn);
            }
            else
            {
                maxn=max(num,maxn);
                num=0;
            }
        }
        d[i]=maxn;
       // cout<<d[i]<<endl;
    }
    while(t--)
    {
       // int MAX=-1;
        int x,y;
        cin>>x>>y;
        // mp[x][y]=~mp[x][y];
        if(mp[x][y])
        {
            mp[x][y]=0;
        }
        else
        {
            mp[x][y]=1;
        }
        int sum=0;
        int MAX=-1;
        for(int j=1;j<=m;j++)
        {
            if(mp[x][j])
            {
                sum++;
                MAX=max(sum,MAX);
            }
            else
            {
                MAX=max(sum,MAX);
                sum=0;
            }
        }
        d[x]=MAX;
        int MMAX=-1;
      //  cout<<MAX<<endl;
        for(int i=1;i<=n;i++)
        {
            MMAX=max(MMAX,d[i]);
        }
        cout<<MMAX<<endl;
    }

    return 0;
}

  

时间: 2024-10-19 08:41:09

Codeforces Round #305 (Div. 2) B的相关文章

暴力 Codeforces Round #305 (Div. 2) B. Mike and Fun

题目传送门 1 /* 2 暴力:每次更新该行的num[],然后暴力找出最优解就可以了:) 3 */ 4 #include <cstdio> 5 #include <cstring> 6 #include <iostream> 7 #include <algorithm> 8 #include <string> 9 using namespace std; 10 11 const int MAXN = 5e2 + 10; 12 const int

set+线段树 Codeforces Round #305 (Div. 2) D. Mike and Feet

题目传送门 1 /* 2 题意:对于长度为x的子序列,每个序列存放为最小值,输出长度为x的子序列的最大值 3 set+线段树:线段树每个结点存放长度为rt的最大值,更新:先升序排序,逐个添加到set中 4 查找左右相邻的位置,更新长度为r - l - 1的最大值,感觉线段树结构体封装不错! 5 详细解释:http://blog.csdn.net/u010660276/article/details/46045777 6 其实还有其他解法,先掌握这种:) 7 */ 8 #include <cstd

数论/暴力 Codeforces Round #305 (Div. 2) C. Mike and Frog

题目传送门 1 /* 2 数论/暴力:找出第一次到a1,a2的次数,再找到完整周期p1,p2,然后以2*m为范围 3 t1,t2为各自起点开始“赛跑”,谁落后谁加一个周期,等到t1 == t2结束 4 详细解释:http://blog.csdn.net/u014357885/article/details/46044287 5 */ 6 #include <cstdio> 7 #include <algorithm> 8 #include <cstring> 9 #in

字符串处理 Codeforces Round #305 (Div. 2) A. Mike and Fax

题目传送门 1 /* 2 字符串处理:回文串是串联的,一个一个判断 3 */ 4 #include <cstdio> 5 #include <cstring> 6 #include <iostream> 7 #include <algorithm> 8 #include <string> 9 using namespace std; 10 11 const int MAXN = 1e3 + 10; 12 const int INF = 0x3f3

Codeforces Round #305 (Div. 2)C---Mike and Frog(扩欧+乱搞)

Mike has a frog and a flower. His frog is named Xaniar and his flower is named Abol. Initially(at time 0), height of Xaniar is h1 and height of Abol is h2. Each second, Mike waters Abol and Xaniar. So, if height of Xaniar is h1 and height of Abol is

Codeforces Round #305 (Div. 2)D---Mike and Feet(单调栈)

Mike is the president of country What-The-Fatherland. There are n bears living in this country besides Mike. All of them are standing in a line and they are numbered from 1 to n from left to right. i-th bear is exactly ai feet high. A group of bears

Codeforces Round #305 (Div. 1) B. Mike and Feet

Mike is the president of country What-The-Fatherland. There are n bears living in this country besides Mike. All of them are standing in a line and they are numbered from 1 to n from left to right. i-th bear is exactly ai feet high. A group of bears

Codeforces Round #305 (Div. 1)

547A - Mike and Frog Solution:  先求出两种变化的第一次和第二次变化到目标的时间. 对这四个时间的具体情况需要一些特判 . 然后直接从1到2*N枚举其中一个时间的倍数,然后输出第一个满足要求的答案.  或者求出循环节后用拓展欧几里得求出最小解. 547B - Mike and Feet 题意: 给定一个长度为n(<=2*10^5)的序列,分别求出长度为(1~n)的区间的最小数的最大值. Solution: 可以先预处理以每个数为答案的最长区间. 即从每个数分别从左和

Codeforces Round #305 (Div. 2), problem: (A) Mike and Fax

#include<iostream> #include<cstdio> #include<cstring> using namespace std; char a[1000+100]; bool judge(int m,int n) { for(int i=m;i<=(m+n)/2;i++) if(a[i]!=a[m+n-i]) return 0; return 1; } int main() { int k; while(~scanf("%s"